style(unitproc):timeEpochNS:Minor semicolons
[BK-2020-03.git] / unitproc / bktemp-timeUntilNextDay
CommitLineData
2ea4288a 1#!/bin/bash
2385300a 2# Desc: Template to report seconds until beginning of next day
2ea4288a
SBS
3
4#==BEGIN Define script parameters==
5#===BEGIN Declare local script functions===
5ef33b04
SBS
6yell() { echo "$0: $*" >&2; } # Yell, Die, Try Three-Fingered Claw technique; # Ref/Attrib: https://stackoverflow.com/a/25515370
7die() { yell "$*"; exit 111; }
8try() { "$@" || die "cannot $*"; }
2385300a
SBS
9timeUntilNextDay(){
10 # Desc: Report seconds until next day.
96716339 11 # Version: 1.0.0
2385300a 12 # Output: stdout: integer seconds until next day
5ef33b04 13 # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
2385300a
SBS
14 # Usage: timeUntilNextDay
15 # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
96716339
SBS
16 # Depends: date 8, echo 8, yell, try
17
b03c9c0c 18 local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
96716339 19
b03c9c0c
SBS
20 TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
21 TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
22 SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
2385300a 23 if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
5ef33b04 24 returnState="true";
2385300a 25 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
96716339 26 returnState="warning_zero";
2385300a
SBS
27 yell "WARNING:Reported time until next day exactly zero.";
28 elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
96716339 29 returnState="warning_negative";
2385300a 30 yell "WARNING:Reported time until next day is negative.";
5ef33b04
SBS
31 fi
32
2385300a 33 try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
5ef33b04 34
96716339 35 # Determine function return code
5ef33b04
SBS
36 if [[ "$returnState" = "true" ]]; then
37 return 0;
96716339 38 elif [[ "$returnState" = "warning_zero" ]]; then
5ef33b04 39 return 1;
96716339 40 elif [[ "$returnState" = "warning_negative" ]]; then
5ef33b04
SBS
41 return 2;
42 fi
df807a6c 43} # Report seconds until next day
2ea4288a
SBS
44#===END Declare local script functions===
45#==END Define script parameters==
46
47
48#==BEGIN sample code==
2385300a 49try echo "Time until next day (seconds):$(timeUntilNextDay)" # simple report
5ef33b04 50
2385300a 51if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement for myTTL:$myTTL"; exit 1; fi # Use of exit code to exit early if time <= 0.
2ea4288a 52#==END sample code==
96716339
SBS
53
54# Author: Steven Baltaktei Sandoval
55# License: GPLv3+